Log::Metadata - Crystal 1.7.3

# class Log::Metadata

- Log::Metadata
- Reference
- Object

##
Overview

Immutable structured metadata information for logging.

See `Log.context`, `Log.context=`, `Log::Context#clear`, `Log::Context#set`, `Log.with_context`, and `Log::Emitter`.

NOTE If you'd like to format the context as JSON, remember to `require "log/json"`.

##
Included Modules

- Enumerable({Symbol, Log::Metadata::Value})

##
Defined in:

log/metadata.cr

##
Constructors

- .build(value : NamedTuple | Hash) : self

  Returns a `Metadata` with the information of the argument.

- .build(value : Metadata) : Metadata

  Returns a `Metadata` with the information of the argument.

- .new(parent : Metadata | Nil = nil, entries : NamedTuple | Hash = NamedTuple.new)

##
Class Method Summary

- .empty : Log::Metadata

  Returns an empty `Log::Metadata`.

##
Instance Method Summary

- #==(other : Metadata)
- #==(other)

  Returns `false` (other can only be a `Value` here).

- #[](key : Symbol) : Value
- #[]?(key : Symbol) : Value | Nil
- #each(& : Tuple(Symbol, Value) -> )

  Must yield this collection's elements to the block.

- #empty? : Bool

  Returns `true` if `self` is empty, `false` otherwise.

- #extend(other : NamedTuple | Hash) : Metadata

  Returns a `Log::Metadata` with all the entries of `self` and other.

- #fetch(key, &)
- #hash(hasher)

  See `Object#hash(hasher)`

- #to_s(io : IO) : Nil

  Appends a short String representation of this object which includes its class name and its object address.

### Instance methods inherited from module `Enumerable({Symbol, Log::Metadata::Value})`

accumulate(initial : U) : Array(U) forall U
accumulate : Array({Symbol, Log::Metadata::Value})
accumulate(initial : U, &block : U, {Symbol, Log::Metadata::Value} -> U) : Array(U) forall U
accumulate(&block : {Symbol, Log::Metadata::Value}, {Symbol, Log::Metadata::Value} -> {Symbol, Log::Metadata::Value}) : Array({Symbol, Log::Metadata::Value}) accumulate, all?(& : {Symbol, Log::Metadata::Value} -> ) : Bool
all?(pattern) : Bool
all? : Bool all?, any?(& : {Symbol, Log::Metadata::Value} -> ) : Bool
any?(pattern) : Bool
any? : Bool any?, chunks(&block : {Symbol, Log::Metadata::Value} -> U) forall U chunks, compact_map(& : {Symbol, Log::Metadata::Value} -> _) compact_map, count(& : {Symbol, Log::Metadata::Value} -> ) : Int32
count(item) : Int32 count, cycle(n, & : {Symbol, Log::Metadata::Value} -> ) : Nil
cycle(& : {Symbol, Log::Metadata::Value} -> ) : Nil cycle, each(& : {Symbol, Log::Metadata::Value} -> ) each, each_cons(count : Int, reuse = false, &) each_cons, each_cons_pair(& : {Symbol, Log::Metadata::Value}, {Symbol, Log::Metadata::Value} -> ) : Nil each_cons_pair, each_slice(count : Int, reuse = false, &) each_slice, each_with_index(offset = 0, &) each_with_index, each_with_object(obj : U, & : {Symbol, Log::Metadata::Value}, U -> ) : U forall U each_with_object, empty? : Bool empty?, find(if_none = nil, & : {Symbol, Log::Metadata::Value} -> ) find, find!(& : {Symbol, Log::Metadata::Value} -> ) : {Symbol, Log::Metadata::Value} find!, first(&)
first(count : Int) : Array({Symbol, Log::Metadata::Value})
first : {Symbol, Log::Metadata::Value} first, first? : {Symbol, Log::Metadata::Value} | Nil first?, flat_map(& : {Symbol, Log::Metadata::Value} -> _) flat_map, group_by(& : {Symbol, Log::Metadata::Value} -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &) forall U in_groups_of, includes?(obj) : Bool includes?, index(& : {Symbol, Log::Metadata::Value} -> ) : Int32 | Nil
index(obj) : Int32 | Nil index, index!(& : {Symbol, Log::Metadata::Value} -> ) : Int32
index!(obj) : Int32 index!, index_by(& : {Symbol, Log::Metadata::Value} -> U) : Hash(U, {Symbol, Log::Metadata::Value}) forall U index_by, join(io : IO, separator = "") : Nil
join(separator, io : IO) : Nil
join(separator = "") : String
join(io : IO, separator = "", & : {Symbol, Log::Metadata::Value}, IO -> )
join(separator, io : IO, &)
join(separator = "", & : {Symbol, Log::Metadata::Value} -> ) join, map(& : {Symbol, Log::Metadata::Value} -> U) : Array(U) forall U map, map_with_index(offset = 0, & : {Symbol, Log::Metadata::Value}, Int32 -> U) : Array(U) forall U map_with_index, max : {Symbol, Log::Metadata::Value} max, max? : {Symbol, Log::Metadata::Value} | Nil max?, max_by(& : {Symbol, Log::Metadata::Value} -> U) : {Symbol, Log::Metadata::Value} forall U max_by, max_by?(& : {Symbol, Log::Metadata::Value} -> U) : {Symbol, Log::Metadata::Value} | Nil forall U max_by?, max_of(& : {Symbol, Log::Metadata::Value} -> U) : U forall U max_of, max_of?(& : {Symbol, Log::Metadata::Value} -> U) : U | Nil forall U max_of?, min : {Symbol, Log::Metadata::Value} min, min? : {Symbol, Log::Metadata::Value} | Nil min?, min_by(& : {Symbol, Log::Metadata::Value} -> U) : {Symbol, Log::Metadata::Value} forall U min_by, min_by?(& : {Symbol, Log::Metadata::Value} -> U) : {Symbol, Log::Metadata::Value} | Nil forall U min_by?, min_of(& : {Symbol, Log::Metadata::Value} -> U) : U forall U min_of, min_of?(& : {Symbol, Log::Metadata::Value} -> U) : U | Nil forall U min_of?, minmax : Tuple({Symbol, Log::Metadata::Value}, {Symbol, Log::Metadata::Value}) minmax, minmax? : Tuple({Symbol, Log::Metadata::Value} | Nil, {Symbol, Log::Metadata::Value} | Nil) minmax?, minmax_by(& : {Symbol, Log::Metadata::Value} -> U) : Tuple({Symbol, Log::Metadata::Value}, {Symbol, Log::Metadata::Value}) forall U minmax_by, minmax_by?(& : {Symbol, Log::Metadata::Value} -> U) : Tuple({Symbol, Log::Metadata::Value}, {Symbol, Log::Metadata::Value}) | Tuple(Nil, Nil) forall U minmax_by?, minmax_of(& : {Symbol, Log::Metadata::Value} -> U) : Tuple(U, U) forall U minmax_of, minmax_of?(& : {Symbol, Log::Metadata::Value} -> U) : Tuple(U, U) | Tuple(Nil, Nil) forall U minmax_of?, none?(& : {Symbol, Log::Metadata::Value} -> ) : Bool
none?(pattern) : Bool
none? : Bool none?, one?(& : {Symbol, Log::Metadata::Value} -> ) : Bool
one?(pattern) : Bool
one? : Bool one?, partition(& : {Symbol, Log::Metadata::Value} -> ) : Tuple(Array({Symbol, Log::Metadata::Value}), Array({Symbol, Log::Metadata::Value})) partition, product(initial : Number)
product
product(initial : Number, & : {Symbol, Log::Metadata::Value} -> )
product(& : {Symbol, Log::Metadata::Value} -> _) product, reduce(memo, &)
reduce(&) reduce, reduce?(&) reduce?, reject(& : {Symbol, Log::Metadata::Value} -> )
reject(type : U.class) forall U
reject(pattern) : Array({Symbol, Log::Metadata::Value}) reject, sample(n : Int, random : Random = Random::DEFAULT) : Array({Symbol, Log::Metadata::Value})
sample(random : Random = Random::DEFAULT) : {Symbol, Log::Metadata::Value} sample, select(& : {Symbol, Log::Metadata::Value} -> )
select(type : U.class) : Array(U) forall U
select(pattern) : Array({Symbol, Log::Metadata::Value}) select, size : Int32 size, skip(count : Int) skip, skip_while(& : {Symbol, Log::Metadata::Value} -> ) : Array({Symbol, Log::Metadata::Value}) skip_while, sum(initial)
sum
sum(initial, & : {Symbol, Log::Metadata::Value} -> )
sum(& : {Symbol, Log::Metadata::Value} -> ) sum, take_while(& : {Symbol, Log::Metadata::Value} -> ) : Array({Symbol, Log::Metadata::Value}) take_while, tally(hash)
tally : Hash({Symbol, Log::Metadata::Value}, Int32) tally, tally_by(hash, &)
tally_by(&block : {Symbol, Log::Metadata::Value} -> U) : Hash(U, Int32) forall U tally_by, to_a to_a, to_h
to_h(& : {Symbol, Log::Metadata::Value} -> Tuple(K, V)) forall K, V to_h, to_set : Set({Symbol, Log::Metadata::Value}) to_set, zip(*others : Indexable | Iterable | Iterator, &)
zip(*others : Indexable | Iterable | Iterator) zip, zip?(*others : Indexable | Iterable | Iterator, &)
zip?(*others : Indexable | Iterable | Iterator) zip?

### Class methods inherited from module `Enumerable({Symbol, Log::Metadata::Value})`

element_type(x) element_type

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message = nil) not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.build(value : NamedTuple | Hash) : self #

Returns a `Metadata` with the information of the argument. Used to handle `Log::Context#set` and `Log#Emitter.emit` overloads.

def self.build(value : Metadata) : Metadata #

Returns a `Metadata` with the information of the argument. Used to handle `Log::Context#set` and `Log#Emitter.emit` overloads.

def self.new(parent : Metadata | Nil = nil, entries : NamedTuple | Hash = NamedTuple.new) #

##
Class Method Detail

def self.empty : Log::Metadata #

Returns an empty `Log::Metadata`.

NOTE Since `Log::Metadata` is immutable, it's safe to share this instance.

##
Instance Method Detail

def ==(other : Metadata) #
def ==(other) #
Description copied from class Reference

Returns `false` (other can only be a `Value` here).

def [](key : Symbol) : Value #
def []?(key : Symbol) : Value | Nil #
def each(& : Tuple(Symbol, Value) -> ) #
Description copied from module Enumerable({Symbol, Log::Metadata::Value})

Must yield this collection's elements to the block.

def empty? : Bool #
Description copied from module Enumerable({Symbol, Log::Metadata::Value})

Returns `true` if `self` is empty, `false` otherwise.

    ([] of Int32).empty? # => true
    ([1]).empty?         # => false

def extend(other : NamedTuple | Hash) : Metadata #

Returns a `Log::Metadata` with all the entries of `self` and other. If a key is defined in both, the values in other are used.

def fetch(key, &) #
def hash(hasher) #
Description copied from class Reference

See `Object#hash(hasher)`

def to_s(io : IO) : Nil #
Description copied from class Reference

Appends a short String representation of this object which includes its class name and its object address.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).to_s # => #<Person:0x10a199f20>